/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.ParamCompraPunto;
import com.rjconsultores.ventaboletos.service.ParamCompraPuntoService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderSendaAmigoParamCompraPunto;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;

/**
 *
 * @author Rafius //ParamCompraPunto
 */
@Controller("busquedaParamCompraPuntoController")
@Scope("prototype")
public class BusquedaParamCompraPuntoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ParamCompraPunto> plwParamCompraPunto;
    @Autowired
    private ParamCompraPuntoService paramCompraPuntoService;
    private List<ParamCompraPunto> lsParamCompraPunto;
    private Datebox ini;
    private Datebox fim;
    private MyListbox paramCompraPuntoList;
    private Paging pagingParamCompraPunto;

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        super.doAfterCompose(comp);

        paramCompraPuntoList.setItemRenderer(new RenderSendaAmigoParamCompraPunto());
        paramCompraPuntoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ParamCompraPunto pa = (ParamCompraPunto) paramCompraPuntoList.getSelected();
                verParamCompraPunto(pa);
            }
        });

        lsParamCompraPunto = new ArrayList<ParamCompraPunto>();

        refreshLista();
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {

        lsParamCompraPunto.clear();
        lsParamCompraPunto.addAll(paramCompraPuntoService.buscar(ini.getValue(), fim.getValue()));
        paramCompraPuntoList.setData(lsParamCompraPunto);

        if (paramCompraPuntoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaParamCompraPuntoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verParamCompraPunto(new ParamCompraPunto());
    }

    private void verParamCompraPunto(ParamCompraPunto pa) {
        if (pa == null) {
            return;
        }

        Map args = new HashMap();
        args.put("busquedaParamCompraPuntoController", this);
        args.put("paramCompraPunto", pa);
        args.put("paramCompraPuntoList", paramCompraPuntoList);

        openWindow("/gui/senda_amigo/editarParamCompraPunto.zul",
                Labels.getLabel("busquedaParamCompraPuntoController.window.title"), args, MODAL);
    }

    public void refreshLista() {
        HibernateSearchObject<ParamCompraPunto> tarifaBusqueda =
                new HibernateSearchObject<ParamCompraPunto>(ParamCompraPunto.class, pagingParamCompraPunto.getPageSize());
        tarifaBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwParamCompraPunto.init(tarifaBusqueda, paramCompraPuntoList, pagingParamCompraPunto);
    }

    public Paging getPagingParamCompraPunto() {
        return pagingParamCompraPunto;
    }

    public void setPagingParamCompraPunto(Paging pagingParamCompraPunto) {
        this.pagingParamCompraPunto = pagingParamCompraPunto;
    }

    public List<ParamCompraPunto> getLsParamCompraPunto() {
        return lsParamCompraPunto;
    }

    public void setLsParamCompraPunto(List<ParamCompraPunto> lsParamCompraPunto) {
        this.lsParamCompraPunto = lsParamCompraPunto;
    }

    public MyListbox getParamCompraPuntoList() {
        return paramCompraPuntoList;
    }

    public void setParamCompraPuntoList(MyListbox paramCompraPuntoList) {
        this.paramCompraPuntoList = paramCompraPuntoList;
    }

    public ParamCompraPuntoService getParamCompraPuntoService() {
        return paramCompraPuntoService;
    }

    public void setParamCompraPuntoService(ParamCompraPuntoService paramCompraPuntoService) {
        this.paramCompraPuntoService = paramCompraPuntoService;
    }

    public PagedListWrapper<ParamCompraPunto> getPlwParamCompraPunto() {
        return plwParamCompraPunto;
    }

    public void setPlwParamCompraPunto(PagedListWrapper<ParamCompraPunto> plwParamCompraPunto) {
        this.plwParamCompraPunto = plwParamCompraPunto;
    }

    public Datebox getFim() {
        return fim;
    }

    public void setFim(Datebox fim) {
        this.fim = fim;
    }

    public Datebox getIni() {
        return ini;
    }

    public void setIni(Datebox ini) {
        this.ini = ini;
    }
}
